<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class UsedProductMaster extends BaseModel
{
    use HasFactory;

    protected $guarded = [];

    protected static function boot()
    {
        parent::boot();
        static::addGlobalScope('typeScope', function ($builder) {
            if (auth()->check() && auth()->user()->shop_id != null) {
                $builder->where('transition_location_id', auth()->user()->shop_id);
            }
        });
        static::creating(function ($model) {
            if (auth()->check()) {
                $user = auth()->user();
                $model->transition_location_id = $user->shop_id;
                $model->transition_create_by = $user->id;
            }
        });

        static::updating(function ($model) {
            if (auth()->check()) {
                $model->transition_update_by = auth()->id();
            }
        });
    }

    public function details()
    {
        return $this->hasMany(UsedProductDetails::class, 'used_product_master_id', 'id')->with('attribute', 'product', 'stock');
    }

    public function detailsTotal()
    {
        return $this->hasMany(UsedProductDetails::class, 'used_product_master_id', 'id')
            ->selectRaw('SUM(used_qty) total ,used_product_master_id,id')
            ->groupBy('used_product_master_id', 'id');
    }

    public function location()
    {
        return $this->hasOne(Warehouse::class, 'id', 'location_id');
    }
}
